/**************************************
* calcul du terme de al suite récurente
*
* entrée :
*   - n : indice du terme de la suite
*
* sortie :
*   - u(n)
***************************************/
float suiteU(int n) {
  if (n == 0)
    return 0.8;
  else {
     // utilisation d'une variable pour éviter de calculer 2 fois u(n - 1)
    float u = suiteU(n - 1);
    return 0.6 * u * (u - 1) ;
  }
}

/**************************************
* calcul du terme de la suite de Fibonacci de manière récurrente
* remarque : la méthode n'est pas très efficace 
*   puisqu'elle calcule de nombreuse fois le même terme
*
* entrée :
*   - n : indice du terme de la suite
*
* sortie :
*   - fibonacci(n)
***************************************/
int fibonacci(int n) {
  if (n == 0)
    return 1;
  else  
    if (n == 1)
      return 1;
    else
      return fibonacci(n - 1) + fibonacci(n - 2);
}

/**************************************
* calcul du terme de la suite de Fibonacci de manière récurrente
* remarque : efficace et à méditer
*
* entrée :
*   - n : indice du terme de la suite
*   - u : terme précédent u(n - 1)
*   - v : terme précédant u : u(n - 2)
*
* sortie :
*   - fibonacci(n)
***************************************/
int fibonacciIter(int n, int u, int v) {
  if (n == 0)
    return v;
  else  
    if (n == 1)
      return u;
    else
      return fibonacciIter(n - 1, u + v, u);
}

/**************************************
* calcul de la suite d'ackerman
*
* entrée :
*   - m : 1er indice du terme de la suite
*   - n : 2nd indice du terme de la suite
*
* sortie :
*   - A(m, n)
***************************************/
int ackerman(int m, int n) {
  if (m == 0)
    return n + 1;
  else  
    if (n == 0)
      return ackerman(m - 1, 1);
    else
      return ackerman(m - 1, ackerman(m, n - 1));
}

void setup() {
  println(suiteU(2));
  println(suiteU(50));
  println(fibonacci(2));
  println(fibonacci(12));
  println(fibonacciIter(2, 1, 1));
  println(fibonacciIter(12, 1, 1));
  println(ackerman(3, 2));
}
